QGIS Application - Bug report #7075
Create WFS Layer in stand alone python script
2013-01-29 04:31 PM - Jeremy Palmer

Status: Closed

Priority: Normal

Assignee: Marco Hugentobler

Category: Web Services clients/WFS

Affected QGIS version:master Regression?: No
Operating System: ubuntu Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 16159
Description

The following script hangs with CPU 100%:
from PyQt4.QtCore import *
from PyQt4.QtXml import *
from qgis.core import *

from qgis.gui import *

QgsApplication.setPrefixPath("/usr", True)
QgsApplication.initQgis()

sourceUri = "http://foo/bar"

layer = QgsVectorLayer(sourceUri, "My WFS layer", "WFS")

outputs following Qt warnings:
QEventLoop: Cannot be used without QApplication

QDBusConnection: system D-Bus connection created before QCoreApplication. Application may misbehave.
QEventLoop: Cannot be used without QApplication

Could this be because the WFS driver normally tries to create a GUI process dialog when running within the QGIS app?

History

#1 - 2013-01-30 12:10 PM - Marco Hugentobler

| think the problem is that there is no instance of QgsApplication in the script (QEventLoop: Cannot be used without QApplication). Try something like this
(not tested, so only a rough indication):

def main( argv ):
theApplication = QgsApplication( argv, False )
QgsApplication.setPrefixPath( ‘/usr', True)
providerRegistry = QgsProviderRegistry.instance( QgsApplication.pluginPath() )
sourceUri = "http://foo/bar"
layer = QgsVectorLayer(sourceUri, "My WFS layer", "WFS")
#2 - 2013-01-30 12:11 PM - Marco Hugentobler
- Status changed from Open to Feedback

#3 - 2013-01-30 12:28 PM - Jeremy Palmer
- Status changed from Feedback to Closed

Thanks that works even, if a little non-standard. All other providers I've used don't need this.

#4 - 2013-01-30 10:23 PM - Marco Hugentobler

All other providers I've used don't need this.

It is because QNetworkAccessManager class needs a Qt event loop.
